msg/urls.py
from . import views
from django.urls import path

app_name = 'msg'

urlpatterns = [
    path('', views.comment_list, name='comment_list'),
    path('comment_create/', views.comment_create, name="comment_create"),
    path('reply_create/<int:comment_id>/', views.reply_create, name="reply_create"),
    path("like/", views.like, name="like")
]

sbf_pti/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.conf import settings
from django.conf.urls.static import static
from portfolio_page import views


urlpatterns = [
    path('admin/', admin.site.urls),
    path('home/', include('portfolio_page.urls')),
    path('message/', include('msg.urls')),
    path('accounts/', include('accounts.urls')),
    path('friends/', include('friends.urls')),
    path("", views.index, name="home")

]

urlpatterns+=staticfiles_urlpatterns()
urlpatterns+=static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

msg/models.py
from django.db import models
from django.contrib.auth.models import User
from friends.models import Friend

# Create your models here.
class Comment(models.Model):
    author = models.ForeignKey(User, on_delete=models.CASCADE, blank=True, null=True, )
    comment = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return "{} - {}".format(self.author, self.snipped_comment())

    def snipped_comment(self):
        if len(self.comment) > 20 :
            return self.comment[:20] + " ..."
        return self.comment

class Reply(models.Model):
    author = models.ForeignKey(User, on_delete=models.CASCADE, blank=True, null=True,)
    reply_live = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)
    comment = models.ForeignKey(Comment, on_delete=models.CASCADE, blank=True, null=True, related_name="replies")

    def __str__(self):
    	return "{} - {}".format(self.author, self.reply_live)

class Like(models.Model):
    username=models.ForeignKey(User, default=None, on_delete=models.CASCADE)

    def __str__(self):
        return str(self.username)

msg/forms.py
from . import models
from django import forms


class CreateCommentForm(forms.ModelForm):
    comment = forms.CharField(widget=forms.Textarea(attrs={
            "class" : "fields",
            "required" : True,
            "placeholder":"Komentar kamu",
             }))
    class Meta:
           model = models.Comment
           fields=[
           "comment"]
           

class CreateReplyForm(forms.ModelForm):
    replies = forms.CharField(widget=forms.Textarea(attrs={
            "class" : "fields",
            "required" : True,
            "placeholder":"Balas komentar dia ^^",
             }))
    class Meta:
        model = models.Reply
        fields =[
        "replies",]

msg/views.py
from django.shortcuts import render, redirect
from .models import Comment, Reply, Like
from .import forms
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required
from friends.models import Friend


# Create your views here.


def comment_list(request):
    comments = Comment.objects.all()
    comment_form = forms.CreateCommentForm()
    reply_form = forms.CreateReplyForm()
    response = {
        'cmnt' : comments,
        'total_cmnt':len(comments),
        'form' : comment_form,
        'reply_form' : reply_form,
        'likes' : len(Like.objects.all()),
        'first3likes' : Like.objects.all()[:3],
        "restlike" : len(Like.objects.all())-3,

    }
    return render(request, 'msg/message_list.html', response)

@login_required(login_url="accounts:login")
def comment_create(request):
    comment_form = forms.CreateCommentForm(request.POST)
    if request.method == "POST" and comment_form.is_valid():
        instance=comment_form.save(commit=False)
        instance.author = request.user
        instance.save()
        # Message.objects.create(
        #     message = message_form.cleaned_data['message'],
        # )
    return redirect('msg:comment_list')

@login_required(login_url="accounts:login")
def reply_create(request, comment_id):
    reply_form = forms.CreateReplyForm(request.POST)
    comment=Comment.objects.get(pk=comment_id)
    # Comment.objects.get(pk=comment_id).author
    if request.method == "POST" and reply_form.is_valid():
            instance=reply_form.save(commit=False)
            instance.author =request.user
            
            instance.reply_live = reply_form.cleaned_data["replies"]
            instance.comment=comment
            instance.save()
    return redirect('msg:comment_list')

@login_required(login_url="accounts:login")
def like(request):
    likers=request.user
    for lk in Like.objects.all():
        if lk.username == likers:
            return redirect("msg:comment_list")
    Like.objects.create(username = request.user)
    return redirect("msg:comment_list")

msg/templates/msg/message_list.html
{% extends "base_layout.html" %}
{% block content %}
{% load static from staticfiles %}


<div class="header comments">
    <h1 class="judul">Comments</h1>
</div>
<div class="sub_msg_like">
        <div class="sub_msg_like_box">
            <h3>{{ likes }}</h3>
            <p class="sub_msg_like_box_desc">
                {% if likes > 1 %}
                    Likes
                {% else %}
                    Like
                {% endif %}
            </p>
        </div>
    <form action="{% url 'msg:like' %}" method="POST">
        {% csrf_token %}
        <button type="submit" class="sub_msg_like_button">
            <img src="{% static 'msg/img/love.png' %}" alt="">
        </button>
    </form>  
    <p class="bawah">
        {% if likes > 0 %}
            {% for lk in first3likes %} 
                {{ lk.username }}, 
            {% endfor %}
            {% if restlike >= 1 %}
                dan {{ restlike }} orang lainnya
            {% endif %}
            menyukai website ini.
        {% endif %}    
    </p>
</div>
<div class="total_comment">
    <h4>{{ total_cmnt }} Komentar</h4>
</div>
<form action="{% url 'msg:comment_create' %}" method="POST" class="sub_msg_comment">
    <label for="#add!">Tambah komentar kamu:</label>
    {% csrf_token %}
    <div>
        {% for field in form.visible_fields %}
            {{ field }}
        {% endfor %}
    </div>
    <button type="submit" id="add!">Add!</button>
</form>
    {% for comment in cmnt %}
        <div class="sub_msg_thecomment_reply" id="{{comment.created_at}}"> 
            <div class="targetreplying" id="replybox{{comment.created_at}}">
            <div class="sub_msg_thecomment_reply_commentsection_content_wrapper" id="sembunyikan{{comment.created_at}}">
            <div class="canceled_reply" id="canceled{{comment.created_at}}">
            <div class="sub_msg_thecomment_reply_commentsection_title cf">
                <h6>{{ comment.author.username }}</h6>
                <span>{{ comment.created_at }}</span>
            </div>
            <p>{{ comment.comment }}</p>
            <p class="replybox"><a href="#replybox{{comment.created_at}}">Balas</a></p>
            <form method="POST" action="{% url 'msg:reply_create' comment_id=comment.id %}" class="sub_msg_thecomment_reply_replysection_button cf">
                    {% csrf_token %}
                <div>
                        {% for field in reply_form.visible_fields %}
                        {{ field }}
                    {% endfor %}
                    <button type="submit" method="POST" class="reply_me">Balas</button>
                    <p class="batal"><a href="#canceled{{comment.created_at}}">Batal</a></p>
                </div>
            
            <!-- reply content section -->
            </form>
            <p class="lihat_balasan"><a href="#{{comment.created_at}}" >lihat balasan</a></p>
            <p class="sembunyikan_balasan"><a href="#sembunyikan{{comment.created_at}}">sembunyikan balasan</a></p>
            <div class="sub_msg_thecomment_reply_commentsection_content">
                <p class="balasan">Balasan:</p>
                {% for reply in comment.replies.all %}
                <div>
                    {{ reply.reply_live }} oleh <span class="reply_author">{{ reply.author.username }}</span> pada {{reply.created_at}}
                </div>
                {% endfor %}
            </div>
            </div>
            </div>
            </div>
        </div>
        
    {% endfor %}

{% endblock %}